using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace DigiDesign
{
    public abstract class DigitalObject
    {
        public ToolboxStrip.DigiTool toolType;
        public int numInputs;
        public int numOutputs;

        public int uniqueId;

        public List<int> inputUniqeId = new List<int>();
        public List<int> outputUniqeId = new List<int>();

        public int xPos;
        public int yPos;

        public DigitalObject[] inputs = null;
        public DigitalObject[] outputs = null;

        public Point[] inputPoints = null;
        public Point[] outputPoints = null;

        public LineDrawing[] lineDrawing = null;

        public void setPosition(int x, int y) {
            xPos = x;
            yPos = y;
        }

        public override string ToString() {
            return "" + toolType + " (" + xPos + ", " + yPos + ")";
        }

        public void drawLineDrawing(Graphics g, Pen p, int locx, int locy) {
            foreach (LineDrawing l in lineDrawing) {
                l.drawLineDrawing(g, p, locx, locy);
            }
        }

        public void drawLineDrawing(Graphics g, Pen p) {
            foreach (LineDrawing l in lineDrawing) {
                l.drawLineDrawing(g, p, xPos, yPos);
            }
        }


    }
}
