using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DigiDesign
{
    public partial class Form1 : Form
    {

        private Bitmap bmp = new Bitmap(400, 300);
        List<DigitalObject> scenegraph = new List<DigitalObject>();
        VHDLWriter vwriter = null;

        AndGate dummyAnd = new AndGate();
        OrGate dummyOr = new OrGate();
        NotGate dummyNot = new NotGate();

        public Form1() {
            InitializeComponent();

            pictureBox1.Image = bmp;
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e) {
            Application.Exit();
        }

        int startx = 0, starty = 0;
        int mousex, mousey;
        public const int hotspotThreshold = 8;
        bool wireStarted = false;
        int wireStartx, wireStarty;

        int wireStartToolIndex = 0;
        int wirePortIndex = 0;
        bool wireInputPort = false;

        int wireStartToolIndex1 = 0;
        int wirePortIndex1 = 0;
        bool wireInputPort1 = false;

        private void pictureBox1_Paint(object sender, PaintEventArgs e) {
            switch (toolBoxStrip1.selectedTool) {
                case ToolboxStrip.DigiTool.Wire:
                    if (!wireStarted) {
                        //see if it is somewhere where wire may start or end..
                        if (nearWireHotSpot())
                            drawWireHotSpot(e.Graphics);
                    }
                    if (wireStarted) {
                        drawWire(e.Graphics);
                        if (nearWireHotSpot())
                            drawWireHotSpot(e.Graphics);
                    }
                    break;
                case ToolboxStrip.DigiTool.Bus:
                   // pictureBox1.Cursor = Cursors.Cross;
                    break;
                case ToolboxStrip.DigiTool.AndGate:
                    dummyAnd.drawLineDrawing(e.Graphics, normalPen, startx, starty);
                    //drawAndGate(e.Graphics);
                    break;
                case ToolboxStrip.DigiTool.OrGate:
                    dummyOr.drawLineDrawing(e.Graphics, normalPen, startx, starty);
                    //drawOrGate(e.Graphics);
                    break;
                case ToolboxStrip.DigiTool.NotGate:
                    dummyNot.drawLineDrawing(e.Graphics, normalPen, startx, starty);
                    //drawNotGate(e.Graphics);
                    break;
                case ToolboxStrip.DigiTool.XorGate:
                    break;
                default:
                    break;
            }
        }

        private void drawWire(Graphics graphics) {
            graphics.DrawLine(normalPen, wireStartx, wireStarty, startx, starty);
        }

        private void drawFinalWire(Graphics graphics) {
            if (wireInputPort) {
                graphics.DrawLine(normalPen, wireStartx, wireStarty,
                    scenegraph[wireStartToolIndex].xPos + scenegraph[wireStartToolIndex].inputPoints[wirePortIndex].X,
                    scenegraph[wireStartToolIndex].yPos + scenegraph[wireStartToolIndex].inputPoints[wirePortIndex].Y);
            }
            else {
                graphics.DrawLine(normalPen, wireStartx, wireStarty,
                    scenegraph[wireStartToolIndex].xPos + scenegraph[wireStartToolIndex].outputPoints[wirePortIndex].X,
                    scenegraph[wireStartToolIndex].yPos + scenegraph[wireStartToolIndex].outputPoints[wirePortIndex].Y);
            }
        }


        private void drawWireHotSpot(Graphics graphics) {
            if (wireInputPort)
                graphics.DrawRectangle(Pens.Red,
                    scenegraph[wireStartToolIndex].xPos + scenegraph[wireStartToolIndex].inputPoints[wirePortIndex].X - 3,
                    scenegraph[wireStartToolIndex].yPos + scenegraph[wireStartToolIndex].inputPoints[wirePortIndex].Y - 3,
                    6, 6);
            else
                graphics.DrawRectangle(Pens.Red,
                    scenegraph[wireStartToolIndex].xPos + scenegraph[wireStartToolIndex].outputPoints[wirePortIndex].X - 3,
                    scenegraph[wireStartToolIndex].yPos + scenegraph[wireStartToolIndex].outputPoints[wirePortIndex].Y - 3,
                    6, 6);
    }

        private bool nearWireHotSpot() {

            for (int i = 0; i < scenegraph.Count; i++) {
                DigitalObject dobj = scenegraph[i];
                if (dobj.toolType == ToolboxStrip.DigiTool.Wire) continue;//may need to change later
                for (int j = 0; j < dobj.inputPoints.Length; j++) {
                    if (Math.Abs(dobj.xPos + dobj.inputPoints[j].X - mousex) < hotspotThreshold
                        && Math.Abs(dobj.yPos + dobj.inputPoints[j].Y - mousey) < hotspotThreshold) {
                        wireInputPort = true;
                        wireStartToolIndex = i;
                        wirePortIndex = j;
                        return true;
                    }
                }
                for (int j = 0; j < dobj.outputPoints.Length; j++) {
                    if (Math.Abs(dobj.xPos + dobj.outputPoints[j].X - mousex) < hotspotThreshold
                        && Math.Abs(dobj.yPos + dobj.outputPoints[j].Y - mousey) < hotspotThreshold) {
                        wireInputPort = false;
                        wireStartToolIndex = i;
                        wirePortIndex = j;
                        return true;
                    }
                }

            }


            return false;
        }

        Pen normalPen = Pens.Black;

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e) {
            mousex = e.X;
            mousey = e.Y;
            startx = (e.X/5)*5;
            starty = (e.Y/5)*5;
            pictureBox1.Refresh();
        }

        private void pictureBox1_MouseEnter(object sender, EventArgs e) {

        }

        private void pictureBox1_MouseLeave(object sender, EventArgs e) {
            Cursor.Show();
        }



        private void pictureBox1_Click(object sender, EventArgs e) {

            DigitalObject dobj = null;

            //then draw on the bitmap.
            Graphics g = Graphics.FromImage(bmp);

           switch (toolBoxStrip1.selectedTool) {
                case ToolboxStrip.DigiTool.Wire:
                    if (!wireStarted) {
                        wireStarted = true;

                        //save the info abt the digital objects
                        wirePortIndex1 = wirePortIndex;
                        wireInputPort1 = wireInputPort;
                        wireStartToolIndex1 = wireStartToolIndex;

                        if (wireInputPort) {
                            wireStartx = scenegraph[wireStartToolIndex].xPos + scenegraph[wireStartToolIndex].inputPoints[wirePortIndex].X;
                            wireStarty = scenegraph[wireStartToolIndex].yPos + scenegraph[wireStartToolIndex].inputPoints[wirePortIndex].Y;
                        }
                        else {
                            wireStartx = scenegraph[wireStartToolIndex].xPos + scenegraph[wireStartToolIndex].outputPoints[wirePortIndex].X;
                            wireStarty = scenegraph[wireStartToolIndex].yPos + scenegraph[wireStartToolIndex].outputPoints[wirePortIndex].Y;
                        }

                    }
                    else {
                        drawFinalWire(g);
                        DigitalObject wire = new Wire();

                        if (wireInputPort) {
                            //then it is going into input at 2nd pt
                            wire.outputs[0] = scenegraph[wireStartToolIndex];
                            scenegraph[wireStartToolIndex].inputs[wirePortIndex] = wire;
                        }
                        else {
                            wire.inputs[0] = scenegraph[wireStartToolIndex];
                            scenegraph[wireStartToolIndex].outputs[wirePortIndex] = wire;
                        }

                        if (wireInputPort1) {
                            wire.outputs[0] = scenegraph[wireStartToolIndex1];
                            scenegraph[wireStartToolIndex1].inputs[wirePortIndex1] = wire;
                        }
                        else {
                            wire.inputs[0] = scenegraph[wireStartToolIndex1];
                            scenegraph[wireStartToolIndex1].outputs[wirePortIndex1] = wire;
                        }

                        scenegraph.Add(wire);
                        wireStarted = false;
                    }
                    break;
                case ToolboxStrip.DigiTool.Bus:
                    break;
                case ToolboxStrip.DigiTool.AndGate:
                    dobj = new AndGate();
                    dobj.setPosition(startx, starty);
                    scenegraph.Add(dobj);
                    dobj.drawLineDrawing(g, normalPen);
                    //drawAndGate(g);
                    break;
                case ToolboxStrip.DigiTool.OrGate:
                    dobj = new OrGate();
                    dobj.setPosition(startx, starty);
                    scenegraph.Add(dobj);
                    dobj.drawLineDrawing(g, normalPen);
                    //drawOrGate(g);
                    break;
                case ToolboxStrip.DigiTool.NotGate:
                    dobj = new NotGate();
                    dobj.setPosition(startx, starty);
                    scenegraph.Add(dobj);
                    dobj.drawLineDrawing(g, normalPen);
                    //drawNotGate(g);
                    break;
                case ToolboxStrip.DigiTool.XorGate:
                    break;
                default:
                    break;
            }
        }



        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e) {
            vwriter = new VHDLWriter("topmodule.vhd", "topmodule");
            vwriter.writeHeader();
            vwriter.findInputAndOutputNodes(scenegraph);
            vwriter.writeEntity();
            vwriter.findNumWires(scenegraph);
            vwriter.writeSignalDeclarations();
            vwriter.writeConnections(scenegraph);
            vwriter.writeFooter();
        }


    }
}